function [result,vars] = analysedata(filename)
% HOMOTOPY         Get sample roots and variables from file named 'data.roots' which is generated by 'hom4ps2.bat'
%
% Yijun. Zhu, 28 March 2013
%
%filename = 'data.roots';
%fileStr = textread(filename,'%s','whitespace','','bufsize', 65536);
if ~exist(filename, 'file')
    error(['Cannot find the file [ ',  filename, ' ]. Maybe the polynomial string is too long to call HOM4PS2. It means that you cannot use [option.demand = each_component] due to the constraint of HOM4PS2 ']);
end
fid = fopen(filename,'r');
best_data = [];
while 1
    tline=fgetl(fid);
    if ~ischar(tline),break;end
    best_data = [best_data,tline];
end
fclose(fid);
fileStr{1}=best_data;

blockStr = regexp(fileStr, '---------------------------------------', 'split');
num = length(blockStr{1}); % the number of solution is (num-1)
j = 1;
result=[];
for i = 1 : num-1 
    block{i} = blockStr{1}{i};
    result_t{i} = analysis_ansblock(block{i});
    if ~isempty(result_t{i})
        result{j} = result_t{i};
        j = j + 1;
    end
end
vars_block = blockStr{1}{num};
vars = get_vars(vars_block);