function vars = get_vars(vars_block)
%  The order of variables : 
%  x1
%  x5
%  x2
%  x3
%  x4
%  
%  ===============>   HOM4PS-2.0   <===============
%  The # of roots      =        5
%  The # of real roots =        3
%  The # of paths followed =       19
%  The # of blow_up        =        0  (before endgame)
%  
%  Department of Mathematics, Michigan State University
%  Contact Info: 
%           Tsung-Lin Lee     : leetsung@msu.edu
%           Tien-Yien Li      : li@math.msu.edu
%           Chih-Hsiung Tsai  : tsaichih@msu.edu

vars_block = regexp(vars_block, '===============>', 'split');
vars_block = regexp(vars_block{1},':','split');
vars_raw = regexp(vars_block{2},' ','split');
length_raw = length(vars_raw);
j = 1;
for i = 1 : length_raw
   vars_raw{i} = delspace(vars_raw{i}); %delete redundant space
   if ~strcmp(vars_raw{i},'') % check if it is empty string
       if ~isempty(vars_raw{i}) % check if it is empty
           vars{j} = vars_raw{i};
           j = j + 1;
       end
   end
end
end

function outStr = delspace(inStr)
index = ~isspace(inStr);
outStr = inStr(index);
end