function  poly_list = nonradical_poly(L,vars)
% NONRADICAL_POLY       
%
%The instruction
%  
%   poly_list = NONRADICAL_POLY(L,vars)
%
%  Input : 
%       L -- sym type polynomials 
%       vars -- variables
% Output :
%       poly_list -- results
%
% Yijun. Zhu, 28 March 2013
%
n = length(vars);                 
M_jac = jacobian(L,vars);
u1 = randi([-100 100],n,1).';
u1 = u1/norm(u1,2);
v1 = randi([-100 100],n,1).';
v1 = v1/norm(v1,2);
M_sub = u1.*vars - v1;
M_extend = [M_jac;M_sub];
res_L = [];
for i = 1 : n
    M_temp = M_extend([1:i-1,i+1:end],:);
    res_L = [res_L,det(M_temp)];
end
all_list = [L,res_L];
poly_list = linearCombine(all_list,vars);
end


function poly_list = linearCombine(all_list,vars)
% Linear combination
n = length(vars);
% Construct a random matrix (n, 2*n), which is of full rank:
A = -2 + 4.*rand(n, 2*n); % a + (b-a).*rand(n,2*n )     generate values from the uniform distribution on the interval [a, b]:
poly_list=[];
for i = 1 : n 
    temp = A(i,:)*all_list(:);
    poly_list = [poly_list,temp];     
end
end