function [X,s] = flat_extension(M,num_var,t,d,ranktol)
    
    flag = 0;
    L = zeros(1,t);    
    kmax = t;
        
    fprintf('Check ranks of moments matrices (rel gap svd = %.4e):\n',...
        ranktol);
    
%     disp(['Rank shift = ' int2str(d)]);
    
    
    U = cell(1,kmax); S = cell(1,kmax);
    rankM = zeros(1,kmax);
    
    oldrank = 1;
    rankdiff = 0;
    rankcheck = false;
    
    
    k = 0;
    while (k < kmax) && ~rankcheck
        k = k+1;
        L(k) = nchoosek(num_var+k,k);
        [U{k},S{k}] = svd(M(1:L(k),1:L(k)));
        num2 = length(find(S{k} > 1e-8));% set another tolerence of rank
     
        % Detect rank drop
        S{k} = diag(S{k}); n = length(S{k});
        drop = find(S{k}(2:n) ./ S{k}(1:n-1) < ranktol); 
        if ~isempty(drop)
            rankM(k) = min(drop(1),num2);
        else
            rankM(k) = min(n,num2);
        end
        fprintf(['Moment matrix of order %2d has size %2d ' ...
 	      'and rank %2d\n'], k, size(U{k},1),rankM(k));
      
        % Check rank condition (flat extension)
        if rankM(k) <= oldrank
            rankdiff = rankdiff + 1;
        else
            rankdiff = 0;
        end
     
        
        if (k>=2*d) && (rankM(k) == oldrank) && ~rankcheck
            rankcheck = true;
            flag = 1;
            X = M(1:L(k),1:L(k));
            s = k;
            disp(['Rank shift = ' int2str(1)]);
        end
        
        
        if (rankdiff >= d) && ~rankcheck
            rankcheck = true;
            flag = 1;
            X = M(1:L(k),1:L(k));
            s = k;
            disp(['Rank shift = ' int2str(d)]);
        end
        
        
        oldrank = rankM(k);
   
    end
    
    if flag
        disp(' Rank conditions may ensure global optimality!');
    else
        disp(' Rank conditions cannot ensure global optimality!');
        X = 0; s=0;
    end
    
    

    