function newL = nullspaceCons4NonSquare(L,vars,appx)
% function newL = construct_method2(L,vars,appx)
% NULLSPACECONS4NONSQUARE      Use 'nullspace' method to construct (n-m)  new polynomials,  and combine  new polynomials and old polynomials into one polynomial system
%
%The instruction
%  
%   newL = NULLSPACECONS4NONSQUARE(L,vars,appx)
%
%  Input : 
%       L -- sym type polynomials 
%       vars -- variables
%       appx -- sample point
% Output :
%       newL -- new polynomials system
%
% Yijun. Zhu, 28 March 2013
%
varNum = length(vars);
LNum = length(L);
u = myrandom(-1,1,1,varNum); %
horiVec = vars - u; 
horiVec = horiVec.*horiVec;
g = sum(horiVec); % gʽ
system = [L,g];
% system = L;

% Generate transposition of jacobian matrix
M = jacobian(system,vars);
M = M.'; 

% Using singular value decomposition with the sample point
M_eval = subs(M,vars,appx);
[U,S,V] = svd(M_eval);

%index
SRowNum = size(S,1); % ȡSԪ
diag = ones(1,SRowNum)*S; % ȡ
index = 1 : length(diag);
index = index(diag<1e-5); % ȡindex

% 
if ~isempty(index) % ʱ
    % ȡһ
    disp('ʹ!')
    randIndex = randi(length(index));
    vecIndex = index(randIndex);
    v = V(:,vecIndex);
else % ʱ
    disp('ʹ!')
    % һ
    randCoefVec = myrandom(-1,1,length(diag),1);
    v = randCoefVec;
%     randCoefVec = myrandom(-1,1,LNum+1,1);
%     v = randCoefVec;
%     v = [4/5,3/5];
end

% % pick up one random vector
% randCoefVec = myrandom(-1,1,LNum,1);
% v = randCoefVec;
    
% Generate new polynomial system
h = M*v;
% h = h - subs(h,vars,appx);
newL = linearComb(h,varNum - LNum);
newL = [L,newL];

end
