function [out, vars] = regularVerification(symK, t, option)
% REGULARVERIFICATION          Use 'regular' method to verify
%
%The instruction
%  
%   [out, vars] = REGULARVERIFICATION(symK, t, option)
%
%  Input : 
%       symK -- sym type polynomials 
%       t -- order
%       option -- 
% Output :
%       out -- results
%       vars -- variables
%
% Yijun. Zhu, 28 March 2013
%
regp = construct_regular(symK);
for i = 1 : length(regp)
    [out, vars] = momentsdp(regp{i},t,option);
    if ~isempty(out) && ~isnan(out{1}(1,1))
        break;
    end
end
end