%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This routine computes a basis of the multivariate polynomial. 
% Input:
%      d --- degree
%      n --- the number of variables
% Output:
%      S --- vector referenced by integer in canonical ordering
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function S= vecnumb(n,d)

	tmp1={};
	if   n ==1 
		 for i = 0 :d
		       tmp1{i+1}=[i];
		 end %end for i
	else
         tmp2= vecnumb(n-1,d);
		 idx = 1;
		 for i = 1:length(tmp2)
		      for j = 0:d
			        tmp3 = [j,tmp2{i}];
					if  sum(tmp3)<=d 
					    tmp1{idx} = tmp3;
						idx = idx +1;
					end %end if 
			  end  %end for j
		 end  %end for i
	end  %end if 
	
	tmp4=zeros(1,length(tmp1));
	max=0;
	len = length(tmp1{1});
	for  i=1 :length(tmp1)
	     maxtmp = sum(tmp1{i});
		 if max<maxtmp 
		      max = maxtmp;
		 end %end if
	end %end for i
	for  i=1 :length(tmp1)
	      tmp5=0;
	     for j=1:len
		       tmp5 =tmp5+ tmp1{i}(j)*(10^(len-j));
		 end %end for j
		 tmp5=tmp5+ (max-sum(tmp1{i}))*(10^len);
		 tmp4(i)=tmp5;
	end %end for i 
	%disp(tmp4);
	[tmp4,pos]=sort(tmp4,'descend');
    S =tmp1(pos);	 
%end  %end  function
      