function newff = repvar4inline(ff,vars)
% REPVAR4INLINE        Replace variables in char type polynomials with x(1),x(2),x(3).......
%
%The instruction
%  
%   newff = REPVAR4INLINE(ff,vars)
%
%  Input : 
%       ff -- old char type polynomials 
%       vars -- variables 
% Output :
%       newff -- new char type polynomials
%
% Yijun. Zhu, 28 March 2013
%
num_var = length(vars);
newvars = {};
for i = 1 : num_var
    newvars = {newvars{:},['x(',num2str(i),')']};
end
newff = subs(ff,{vars},newvars); % Use cell type  to avoid compatibility issues
end